
#include "NvListenSocket.h"
#include "NvSockManager.h"

CNvListenSocketEventSink::CNvListenSocketEventSink()
{
}
CNvListenSocketEventSink::~CNvListenSocketEventSink()
{
}
void CNvListenSocketEventSink::OnConnected(CNvTcpSocket *pSocket)
{
	pSocket->Write("Hi.. Happy new year 2008!!!\n", strlen("Hi.. Happy new year 2008!!!")+1);
}
void CNvListenSocketEventSink::OnClosed()
{
}

CNvTcpSocket tcpSocket;

CNvListenSocket::CNvListenSocket()
{
}

CNvListenSocket::~CNvListenSocket()
{
}

int CNvListenSocket::GetSocketID()
{
	return m_nSocketID;
}

bool CNvListenSocket::Create(CNvSockAddr *pLocalAddr)
{
	WSADATA wsaData;
	if(WSAStartup(MAKEWORD(2, 2), &wsaData) != 0) /* Load Winsock 2.2 DLL */
	{
		return false;
	}
	tcpSocket.Create(pLocalAddr);
	m_nSocketID = tcpSocket.GetSocketID();
	return true;
}

bool CNvListenSocket::Listen()
{
	if(listen(m_nSocketID, 5) < 0)
	{
		return false;
	}

	//int clntLen;
	//struct sockaddr_in clntAddr;
	//int clntSock;

	//for(;;)
	//{
	//	clntLen = sizeof(clntAddr);
	//	if((clntSock = accept(m_nSocketID, (struct sockaddr *) &clntAddr, &clntLen)) < 0)
	//	{
	//		return false;
	//	}

	//	CNvTcpSocket clientSocket;
	//	clientSocket.Create(clntSock);
	//
	//	m_pEventSink->OnConnected(&clientSocket);
	//}

	return true;
}

void CNvListenSocket::OnConnected(CNvTcpSocket* clientSocket)
{
	m_pEventSink->OnConnected(clientSocket);
}

void CNvListenSocket::Close()
{
	WSACleanup();
}

void main()
{
	//CNvSockAddr address;
	//address.SetAddrPort(INADDR_ANY, 14591);

	//CNvListenSocket server;

	//CNvListenSocketEventSink listenSocketEventSink;
	//server.Advise(&listenSocketEventSink);

	//server.Create(&address);
	//server.Listen();

	CNvSockManager sockManager;
	sockManager.Start();
}
