#pragma once

#include "NvTcpSocket.h"

class CNvTcpSocket;

class CNvSockManager
{
public:
	CNvSockManager(void);
	virtual ~CNvSockManager(void);
	
	bool Start();
	void Stop();

	bool AddSocket(CNvTcpSocket *pSocket);
	void RemoveSocket(CNvTcpSocket *pSocket);
	int GetSocketNumber();
protected:
	HANDLE m_hThread;

	CNvTcpSocket* m_arrSocket[64];
	size_t m_nSockCount;

	fd_set m_fdReadSet;
	fd_set m_fdWriteSet;
	fd_set m_fdErrSet;
protected:
	static void run0(void *pParam)
	{
		((CNvSockManager *)pParam)->Run(pParam);
	}
	virtual void Run(void *pParam);
	bool m_bRunning;
};
