
#include "NvTcpSocket.h"

CNvTcpSocket::CNvTcpSocket()
{

}

CNvTcpSocket::~CNvTcpSocket()
{

}

bool CNvTcpSocket::Create(CNvSockAddr *pLocalAddrPort)
{
	if((m_nSocketID = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0)
	{
		return false;
	}

	sockaddr_in localAddr;
	pLocalAddrPort->GetSockAddr(localAddr);
	if(bind(m_nSocketID, (struct sockaddr *) &localAddr, sizeof(localAddr)) < 0)
	{
		return false;
	}
	return true;
}

bool CNvTcpSocket::Create(int nSocketID)
{
	m_nSocketID = nSocketID;
	return true;
}

int CNvTcpSocket::GetSocketID()
{
	return m_nSocketID;
}

bool CNvTcpSocket::Connect(CNvSockAddr *pRemoteAddrPort)
{
	sockaddr_in remoteAddr;
	pRemoteAddrPort->GetSockAddr(remoteAddr);
	if(connect(m_nSocketID, (struct sockaddr *) &remoteAddr, sizeof(remoteAddr)) < 0)
	{
		return false;
	}
	return true;
}

int CNvTcpSocket::Read(char *pData,int nMaxSize)
{
	int strLen = recv(m_nSocketID, pData, nMaxSize, 0); /*   */
	return strLen;
}

int	CNvTcpSocket::Write(char *pData,int nSize)
{
	send(m_nSocketID, pData, nSize, 0); /*   */
	return 0;
}

int	CNvTcpSocket::GetLastError()
{
	return GetLastError();
}

void CNvTcpSocket::Close()
{

}